<template>
    <div>
        <modal :name="confirmEmailModal" :adaptive="Boolean" :maxWidth="500" height="auto" styles="border-radius: 10px" classes="auth-form form-ui-style-default">
          <div class="registration-form step-1">
                <div class="form__title">Подтвердите адрес вашей почты</div>

                <div class="form-group form-text-info">
                    {{ confirmationSentText }}<br/>
                    Перейдите по ссылке указанной в письме, чтобы подтвердить почту
                </div>

                <div class="form-group">
                    <label class="label-accept-text">
                        <a v-on:click="resendEmailConfirmation">
                            Отправить новое письмо для подтверждения почты
                        </a>
                    </label>
                </div>

                <div class="form-group">
                    <label class="label-accept-text">
                        <a v-on:click="showEmailField = true">
                            Указать другую почту
                        </a>
                    </label>
                </div>

                <div v-if="showEmailField" class="form-group">
                    <label for="email">Электронная почта <i class="requred"></i></label>

                    <input type="email" v-model="changedEmail" />
                </div>

                <div v-if="errors.length" class="form-validation-errors alert alert-danger">
                    <div v-for="error in errors">
                        {{ error }}
                    </div>
                </div>

                <div v-if="showEmailField" class="form-group">
                    <div class="d-flex justify-content-between form__buttons align-items-center">
                        <button name="next_stage" v-on:click="resendEmailConfirmation" class="btn btn-primary">
                            Отправить
                        </button>
                    </div>
                </div>
            </div>
        </modal>
    </div>
</template>
<script>

export default {
  props: ['email', 'successfully'],
  data() {
      return {
        confirmEmailModal: `confirm-email-modal`,
        confirmationSent: false,
        showEmailField: false,
        confirmationSentText: 'Мы отправили письмо на ' + this.email,
        errors: [],
        changedEmail: this.email,
        success: this.successfully,
      }
  },
  mounted() {
    if (this.success) {
      this.$root.showAlert('Письмо отправлено. Проверьте свою почту.', '');
    }
    this.setModalSession();
    this.toggleModal(this.confirmEmailModal);
  },
  methods: {
    toggleModal(modalName) {
      this.errors = [];
      this.$modal.toggle(modalName);
    },
    async resendEmailConfirmation() {
      await axios
          .post('/email/send-verification/', { email: this.changedEmail })
          .then(result => {
            if (result.data.status == 'success') {
              this.errors = [];

              this.$root.showAlert('Письмо отправлено. Проверьте свою почту.', '');

              if (this.email === this.changedEmail) {
                this.confirmationSentText = 'Мы повторно отправили письмо на ' + this.changedEmail;
              } else {
                this.confirmationSentText = 'Мы отправили письмо на ' + this.changedEmail;

                this.email = this.changedEmail;
              }
            } else {
              console.error(result.request);
            }
          })
          .catch(error => {
            console.error(error);
            this.errors = error.response.data.data.errors.email;
          })
      ;
    },
    setModalSession() {
      axios
          .post('/profile/set-session-profile/')
          .catch(error => {
            console.log(error);
          });
    }
  },
}
</script>
